//                                                        
//   Programa elaborado por Genaro Juarez Martinez        
//   e-mail: genaro@enigma.red.cinvestav.mx               
//               genarojm@correo.unam.mx                             
//   Area: Automatas Celulares                            
//   CINVESTAV IPN                                        
//                                                        

#import "vecindad.h"
int vecin[9];
int largox,largoy;

/*Convierte decimal en binario para la vecindad de Moore*/
int vecindad_binary(int vecino)
{
    int modulo;
    int divisor;
    int i=0;
    do
    {
          modulo = fmod(vecino,2);
          divisor = vecino/2;
          vecin[i] = modulo;
          vecino = divisor;
          i++;
    }while(i<9);
    return 0;
}

@implementation vecindad

/*Inicializa la grafica*/
- initWithFrame:(NSRect)rects
{
    [super initWithFrame:rects];
    [self allocateGState];
    return self;
}

/*Dibuja la grafica*/
-(void)drawRect:(NSRect)rects
{
    /*Limites del cuadro*/
    NSRect limites=[self bounds];
    largox=limites.size.width;
    largoy=limites.size.height;
    [[NSColor whiteColor] set];
    NSRectFill([self bounds]);
    [self dibujaMalla:self];
}

/*Dibuja una linea*/
-(void)dibujarLinea:(int)x1:(int)y1:(int)x2:(int)y2:(float)rojo:(float)verde:(float)azul
{
    PSsetrgbcolor(rojo,verde,azul);
    PSmoveto(x1,y1);
    PSlineto(x2,y2);
}

/*Dibuja la malla*/
-(void)dibujaMalla:(id)sender
{
    int i,j,flag;
    flag=largox/3;
    PSnewpath();
    /*Lineas verticales*/
    for(i=0,j=flag;i<3;i++,j=j+flag)
        [self dibujarLinea:j:0:j:largoy:0.80:0.80:0.80];
    /*Lineas horizontales*/
    for(i=0,j=flag;i<3;i++,j=j+flag)
        [self dibujarLinea:0:j:largox:j:0.80:0.80:0.80];
    PSstroke();
}

/*Dibuja la vecindad*/
-(void)dibujarVecindad:(int)vecino
{
    char s[5];
    /*Transformar de decimal a binario*/
    vecindad_binary(vecino);
    /*Limpiar view*/
    [self display];
    /*Poner texto*/
    [self lockFocus];
    PSsetrgbcolor(0,0,0);
    PSnewpath();
    PSselectfont("Times-Roman",18);
    sprintf(s,"%d",vecin[0]); PSmoveto(13,76); PSshow(s);
    sprintf(s,"%d",vecin[1]); PSmoveto(46,76); PSshow(s);
    sprintf(s,"%d",vecin[2]); PSmoveto(79,76); PSshow(s);
    sprintf(s,"%d",vecin[3]); PSmoveto(13,43); PSshow(s);
    sprintf(s,"%d",vecin[4]); PSmoveto(46,43); PSshow(s);
    sprintf(s,"%d",vecin[5]); PSmoveto(79,43); PSshow(s);
    sprintf(s,"%d",vecin[6]); PSmoveto(13,11); PSshow(s);
    sprintf(s,"%d",vecin[7]); PSmoveto(46,11); PSshow(s);
    sprintf(s,"%d",vecin[8]); PSmoveto(79,11); PSshow(s);
    [self unlockFocus];
}

@end
